<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Track" File Injection Detection                      |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Version 4.2 / December 2013

*/


$trackdb = new DB;
$trackOutput = '';
$trackFiles = array();
$changed = array();

// Track-Daten auslesen
$trackdb->query("SELECT * FROM ".CPO_MOD_TRACK." ORDER BY fs_file ASC ");
while ($trackdb->next_record()) {
	$trackFileName = $trackdb->v('fs_file');
	$trackFiles[$trackFileName]['checksum'] = $trackdb->v('checksum');
	$trackFiles[$trackFileName]['date'] = $trackdb->v('date');
	$trackFiles[$trackFileName]['chmod'] = $trackdb->v('chmod');
}


foreach ($trackFiles AS $trackFileName => $trackFileValues)  {
	$fs_file = $trackFileName;
	$buffer = '';
	if (file_exists($fs_file) || is_readable($fs_file)) {
		$handle = fopen ($fs_file, 'rb');
		if (filesize($fs_file)<=$activeModules['track']['maxFileSize']) $buffer = fread($handle, max(1,filesize($fs_file)));
		fclose ($handle);

		$trackmd5New = md5($buffer);
		$trackstampNew = filemtime($fs_file);
		$trackpermsNew = substr(decoct(fileperms($fs_file)),3);

		$trackmd5 = $trackFileValues['checksum'];
		$trackstamp = $trackFileValues['date'];
		$trackperms = $trackFileValues['chmod'];

		if ($trackmd5 != $trackmd5New || $trackstamp != $trackstampNew || $trackperms != $trackpermsNew)  {
			$changed[$trackFileName] = $trackFileValues;
			$changed[$trackFileName]['checksumNew'] = $trackmd5New;
			$changed[$trackFileName]['dateNew'] = $trackstampNew;
			$changed[$trackFileName]['chmodNew'] = $trackpermsNew;
		}
	} else {
		if ($activeModules['track']['reportItems'] == 'all') $trackOutput .= 'File deleted: '.str_replace(CPO_BASEDIR,'',$fs_file)."\n";
	}
}


if (count($changed) >0)  {
	foreach ($changed AS $trackFileName => $trackFileValues)  {
		$trackmd5 = $trackFileValues['checksum'];
		$trackstamp = $trackFileValues['date'];
		$trackperms = $trackFileValues['chmod'];
		$trackmd5New = $trackFileValues['checksumNew'];
		$trackstampNew = $trackFileValues['dateNew'];
		$trackpermsNew = $trackFileValues['chmodNew'];

		$m_file = ($trackmd5 != $trackmd5New) ? '['.__('File changed').'] ' : '' ; 
		$m_date = ($trackstamp != $trackstampNew) ? '['.__('Date changed').': '.date("d.m.Y H:i",$trackstamp).'  -> '.date("d.m.Y H:i",$trackstampNew).'] ' : '' ; 
		$m_chmod = ($trackperms != $trackpermsNew) ? '['.__('Rights changed').': '.$trackperms.'->'.$trackpermsNew.'] ' : '' ; 

		$fileName = str_replace(CPO_BASEDIR,'',$trackFileName);
		$trackOutput .= '<img src="'.SKIN_URL.'sym_warning.gif"> <b>'.$fileName.'</b> - '.$m_file.$m_date.$m_chmod."\n";
	}
} 

listTrackFiles(substr(CPO_BASEDIR,0,-1),false,false,true);

foreach ($fileList AS $file)  {
	if (!array_key_exists($file,$trackFiles) && $activeModules['track']['reportItems'] == 'all')  $trackOutput .= '<img src="'.SKIN_URL.'sym_note.gif"> '.__('New file').': '.str_replace(CPO_BASEDIR,'',$file)."\n";
}

if (!$trackOutput && TRACKEDIT)  $message[] = __('No changes detected');

?>